##Problem 1 ##
MarkovC = function(a,n,p1,p2){
  for (i in 1:n){
    if(a[i]==0){
      print(sample(c(1,0), prob = c(p1,1-p1),size=1))
    }else if(a[i]==1){
      print (sample(c(1,0),prob = c(p2,1-p2), size=1))
    }
    a[i+1]=a[i]
  }
}

##Problem 2 ##

func2<-function(input){
  starting_location_of_0s_run<-min(which(input == 0));
  starting_location_of_1s_run<-min(which(input != 0));
  output<-list(starting_location_of_0s_run=starting_location_of_0s_run, starting_location_of_1s_run=starting_location_of_1s_run)
  return(output)
}

##Problem 3 ##

func3<-function(input){
  location_of_0s_run<-which(input == 0);
  location_of_1s_run<-which(input != 0);
  output<-list(location_of_0s_run=location_of_0s_run, location_of_1s_run=location_of_1s_run)
  return(output)
}

##Problem 4b ##
#(i)
MarkovC = function(a,n,p1,p2){
  for (i in 1:(n-1)){
    if(a[i]==0){
      a[i+1]<-(sample(c(1,0), prob = c(p1,1-p1),size=1))
    }else if(a[i]==1){
      a[i+1]<-(sample(c(1,0),prob = c(p2,1-p2), size=1))
    }
  }
  output<-list(a)
  return(output)
}

data<-data.frame(MarkovC(1, 10000,0.8,0.1));
colnames(data)<-c('data')

run_length_encoding<-rle(data$data)
starting_location_of_0s_run<-(which(run_length_encoding$values==0 & run_length_encoding$lengths<=10));
starting_location_of_1s_run<-(which(run_length_encoding$values==1 & run_length_encoding$lengths<=10));

starting_location<-data.frame(starting_location_of_0s_run, starting_location_of_1s_run) 
#Pattern between 1's run and 0's run are of same length and consecutive values.

#(ii)
starting_location_of_0s_run<-(which(run_length_encoding$values==0 & run_length_encoding$lengths==4));
starting_location_of_1s_run<-(which(run_length_encoding$values==1 & run_length_encoding$lengths==4));

#(iii)
data<-data.frame(MarkovC(1, 10000,0.5,0.5));
colnames(data)<-c('data')

run_length_encoding<-rle(data$data)
starting_location_of_0s_run<-(which(run_length_encoding$values==0 & run_length_encoding$lengths<=10));
starting_location_of_1s_run<-(which(run_length_encoding$values==1 & run_length_encoding$lengths<=10));

#In part b more runs of 0's and 1's are of lengths up to 10 compared to part a.
